

def sizePart(partition):
    size = 0
    for i in partition:
        size = size + i
    return size  



# this assumes that permutation is in the Partition class
def character(partition,permutation):
    if partition == "nat":
        return permutation.to_list().count(1)
    else:
        size = sizePart(partition)
        all_partitions = [p for p in Partitions(size)]
        return symmetrica.chartafel(size)[all_partitions.index(partition),all_partitions.index(permutation)]




#returns representatives of all conjugacy classes of S_n
def possTrace(n):
    result=[]
    types=[]
    for p in Permutations(n):
        if p.cycle_type() not in types:
            result.append(p)
            types.append(p.cycle_type())
    return result

#returns the symmetry group of perm (must be a Permutation)
def sym_group(perm):
    n = len(perm)
    result = []
    for q in Permutations(n):
        if perm == q*perm*q.inverse():
            result.append(q)
    return result

#return the canonical single trace Permutation([2,3,4...n,1])
def genSingle(n):
    cycle = []
    for i in range(2,n+1):
        cycle.append(i)
    cycle.append(1)
    return Permutation(cycle)


#return the inverse of the canonical single trace Permutation([n,1,2,...n-1])
def genSingle2(n):
    cycle = [n]
    for i in range(1,n):
        cycle.append(i)
    return Permutation(cycle)

#returns the number of ops with trace structure cycle and rep L
def cnTrace(L,cycle):
    n=sizePart(L)
    sum = 0
    count=0
    for perm in sym_group(Permutation(cycle)):
        sum+=character(L,perm.cycle_type())
        count+=1
    return sum/count


#return a permutation with cycle type part
def permFromPart(part):
    for perm in Permutations(sizePart(part)):
        if perm.cycle_type()==part:
            return perm
            break

#return the number of ops with trace structure alpha and rep L
def Smult(L,alpha):
    return cnTrace(L,permFromPart(alpha))



#takes a list [2,2] and returns all perms of this type
def permsOfType(type,n):
    t=0
    for j in type:
        t+=j
    if t > n:
        print "n is too small for this type"
        return []
    for i in range(1,n-t+1):
        type.append(1)
    result=[]
    for p in Permutations(n):
        if p.cycle_type()==type:
            result.append(p)
    return result
    

#return array for \S_1 \S_2 = \sum c_i \S_i
def multSnAlg(type1,type2,n):
    results=[]
    number=[]
    final=[]
    for p in permsOfType(type1,n):
        for q in permsOfType(type2,n):
            temp = (p*q).cycle_type()
            if temp in results:
                number[results.index(temp)]+=1
            else:
                results.append(temp)
                number.append(1)
    for i in range(0,len(number)):
        dummy = len(permsOfType(results[i],n))
        if number[i]%dummy==0:
            final.append([number[i]/dummy,results[i]])
        else:
            print "error number is not integer multiple of conjugacy class size"
            return 0
    return final

# takes arrays for above multiplication
def multSnAlgArr(a1,a2,n):
    results=[]
    number=[]
    final=[]
    for i in a1:
        for j  in a2:
            for k in multSnAlg(i[1],j[1],n):
                if k[1] in results:
                    number[results.index(k[1])]+=i[0]*j[0]*k[0]
                else:
                    results.append(k[1])
                    number.append(i[0]*j[0]*k[0])
    for i in range(0,len(number)):
        dum=number[i]
        if dum !=0:
            final.append([dum,results[i]])      
    return final


def multSnAlgArrFact(a1,a2,n):
    results=[]
    number=[]
    final=[]
    for i in a1:
        for j  in a2:
            for k in multSnAlg(i[1],j[1],n):
                if k[1] in results:
                    number[results.index(k[1])]+=i[0]*j[0]*k[0]
                else:
                    results.append(k[1])
                    number.append(i[0]*j[0]*k[0])
    for i in range(0,len(number)):
        dum=number[i]
        dum=expand(dum)
        if dum !=0:
            final.append([dum,results[i]])      
    return final



##adds array 1 to array2
def addSnAlgArr(array1,array2):

    for x in range(0,len(array1)):
        dummy = 0
        for y  in range(0,len(array2)):
            if array1[x][1]==array2[y][1]:
                dummy = 1
                array2[y][0] = array1[x][0] + array2[y][0]
                if array2[y][0] == 0:
                    array2.pop(y)
                break
        if dummy == 0:
            array2.append(array1[x])



##same as multSnAlgArr by [[factor,[1^n]]]
def multIntSnAlgArr(factor, array):
    
    for i in range(0,len(array)):
        array[i][0] = factor*array[i][0]

